package cz.upol.jj1.lecture10;

import cz.upol.jj.Rental.RentableItem;
import cz.upol.jj.Rental.Rental;

import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

public class Main {


    public static void main(String[] args) {
        Rental<Movie> rental = new Rental<>();
        fillDB(rental);
        rental.sort();
        Scanner s = new Scanner(System.in);
        boolean loop = true;
        while(loop){
            List<Movie> rentedMovies =
                    rental.getItems().stream()
                            .filter(RentableItem::isRented)
                            .map(RentableItem::getItem)
                            .distinct()
                            .collect(Collectors.toList());
            List<Movie> stockMovies =
                    rental.getItems().stream()
                            .filter((var m) -> !m.isRented())
                            .map(RentableItem::getItem)
                            .distinct()
                            .collect(Collectors.toList());
            System.out.println("""
                    Co chcete?
                    1, pujcit film
                    2, vratit film
                    3, projit nabidku
                    4, vybrat pokladnu
                    5, odejit
                    """);

            int action = 0;
            try{
                action = s.nextInt();
            } catch (Exception e){
                System.out.println("Ugh?");
            }
            switch (action) {
                case 1:
                    System.out.println("Ktery film?");
                    for (int i = 0; i < stockMovies.size(); i++) {
                        System.out.println(i + ": " + stockMovies.get(i).toString());
                    }
                    try {
                        int movie = s.nextInt();
                        rental.rent(stockMovies.get(movie));
                    } catch (Exception e) {
                        System.out.println("Ugh?");
                    }
                    break;
                case 2:
                    System.out.println("Ktery film?");
                    for (int i = 0; i < rentedMovies.size(); i++) {
                        System.out.println(i + ": " + rentedMovies.get(i).toString());
                    }
                    try {
                        int movie = s.nextInt();
                        rental.retrieve(new RentableItem<>(rentedMovies.get(movie), 0));
                    } catch (Exception e) {
                        System.out.println("Ugh?");
                    }
                    break;
                case 3:
                    for (int i = 0; i < stockMovies.size(); i++) {
                        System.out.println(i + ": " + stockMovies.get(i).toString());
                    }
                    break;
                case 4:
                    System.out.println("Tady jsou penize: " + rental.getCash());
                    break;
                case 5:
                    loop = false;
                    break;
                default:
                    System.out.println("Ugh?");
                    break;
            }

        }
        s.close();
    }

    private static void fillDB(Rental<Movie> rental){
        rental.add(new Movie(1994, "Pulp Fiction", "Tarantino"), 1000);
        rental.add(new Movie(1994, "Pulp Fiction", "Tarantino"),1000);
        rental.add(new Movie(1994, "Pulp Fiction", "Tarantino"), 1000);
        rental.add(new Movie(1991, "Terminator 2: Judgement day", "Cameron"), 2000);
        rental.add(new Movie(1991, "Terminator 2: Judgement day", "Cameron"), 2000);
        rental.add(new Movie(1991, "Terminator 2: Judgement day", "Cameron"), 2000);
        rental.add(new Movie(1968, "2001: A Space Odyssey", "Kubrick"), 10000003);
    }
}
