package cz.upol.jj1.lecture10;

import cz.upol.jj.Rental.Item;

import java.util.Objects;

public class Movie extends Item implements Comparable<Movie> {

    private final int year;
    private final String name;
    private final String director;

    public Movie(int year, String name, String director) {
        this.year = year;
        this.name = name;
        this.director = director;
    }

    public int getYear() {
        return year;
    }

    public String getName() {
        return name;
    }

    public String getDirector() {
        return director;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Movie movie = (Movie) o;
        return year == movie.year && Objects.equals(name, movie.name) && Objects.equals(director, movie.director);
    }

    @Override
    public int hashCode() {
        return Objects.hash(year, name, director);
    }

    @Override
    public int compareTo(Movie movie) {
        if(!name.equals(movie.getName())){
            return name.compareTo(movie.getName());
        } else if (!director.equals(movie.getDirector())){
            return director.compareTo(movie.getDirector());
        } else {
            return Integer.compare(year, movie.getYear());
        }
    }

    @Override
    public String toString() {
        return "Movie{" +
                "year=" + year +
                ", name='" + name + '\'' +
                ", director='" + director + '\'' +
                '}';
    }
}
